
/*	
	GameboyVM - Nintendo Gameboy Emulator
	Copyright 2002 Y_N y_n@users.sourceforge.jp
	Homepage https://sourceforge.jp/projects/gbemu/
*/


void Cpu_cb(){
	u8 opcode=RMem((u16)(PC+1));

	switch(opcode){	

#define RLC(dest)	RF(_N);RF(_H);if(dest & 0x80)SF(_C);else SF(_C);\
		dest=(dest<<1)|(dest>>7);if(dest)RF(_Z);else SF(_Z)
	case 0x00 : RLC(B);break;
	case 0x01 : RLC(C);break;
	case 0x02 : RLC(D);break;
	case 0x03 : RLC(E);break;
	case 0x04 : RLC(H);break;
	case 0x05 : RLC(L);break;
	case 0x06 : tmp8=RMem(HL);
			RF(_N);RF(_H);if(tmp8 & 0x80)SF(_C);else SF(_C);
			tmp8=(u8)((tmp8<<1)|(tmp8>>7));if(tmp8)RF(_Z);else SF(_Z);
			WMem(HL,tmp8);break;
	case 0x07 : RLC(A);break;

#define RRC(dest)	RF(_N); RF(_H);if(dest & 0x01)SF(_C);else RF(_C);\
		dest=(dest>>1)|(dest<<7);if(dest)RF(_Z);else SF(_Z)
	case 0x08 : RRC(B);break;
	case 0x09 : RRC(C);break;
	case 0x0A : RRC(D);break;
	case 0x0B : RRC(E);break;
	case 0x0C : RRC(H);break;
	case 0x0D : RRC(L);break;
	case 0x0E : tmp8=RMem(HL);
		RF(_N); RF(_H);if(tmp8 & 0x01)SF(_C);else RF(_C);
		tmp8=(u8)((tmp8>>1)|(tmp8<<7));if(tmp8)RF(_Z);else SF(_Z);
		WMem(HL,tmp8);break;
	case 0x0F : RRC(A);break;

#define RL(dest)	RF(_N);RF(_H);if(dest & 0x80)SF(_C);else RF(_C);\
		dest=(dest<<1)|FC; if(dest)RF(_Z);else SF(_Z)
	case 0x10 : RL(B);break;
	case 0x11 : RL(C);break;
	case 0x12 : RL(D);break;
	case 0x13 : RL(E);break;
	case 0x14 : RL(H);break;
	case 0x15 : RL(L);break;
	case 0x16 : tmp8=RMem(HL);
			RF(_N);RF(_H);if(tmp8 & 0x80)SF(_C);else RF(_C);
			tmp8=(u8)((tmp8<<1)|FC);if(tmp8)RF(_Z);else SF(_Z);
			WMem(HL,tmp8);break;
	case 0x17 : RL(A);break;

#define RR(dest)	RF(_N); RF(_H);if(dest & 0x01)SF(_C);else RF(_C);\
		dest=(dest>>1)|((F&_C)<<3); if(dest)RF(_Z);else SF(_Z)
	case 0x18 : RR(B);break;
	case 0x19 : RR(C);break;
	case 0x1A : RR(D);break;
	case 0x1B : RR(E);break;
	case 0x1C : RR(H);break;
	case 0x1D : RR(L);break;
	case 0x1E : tmp8=RMem(HL);
		RF(_N); RF(_H);if(tmp8 & 0x01)SF(_C);else RF(_C);
		tmp8=(u8)((tmp8>>1)|((F&_C)<<3)); if(tmp8)RF(_Z);else SF(_Z);
		WMem(HL,tmp8);break;
	case 0x1F : RR(A);break;

#define SLA(dest)	RF(_N); RF(_H);if(dest & 0x80)SF(_C);else RF(_C);\
		dest<<=1;if(dest)RF(_Z);else SF(_Z)
	case 0x20 : SLA(B);break;
	case 0x21 : SLA(C);break;
	case 0x22 : SLA(D);break;
	case 0x23 : SLA(E);break;
	case 0x24 : SLA(H);break;
	case 0x25 : SLA(L);break;
	case 0x26 : tmp8=RMem(HL);
		RF(_N); RF(_H);if(tmp8 & 0x80)SF(_C);else RF(_C);
		tmp8<<=1;if(tmp8)RF(_Z);else SF(_Z); 
		WMem(HL,tmp8);break;
	case 0x27 : SLA(A);break;

#define SRA(dest)	RF(_N); RF(_H);if(dest & 0x01)SF(_C);else RF(_C);\
		dest=(dest>>1)|(dest & 0x80);if(dest)RF(_Z);else SF(_Z)
	case 0x28 : SRA(B);break;
	case 0x29 : SRA(C);break;
	case 0x2A : SRA(D);break;
	case 0x2B : SRA(E);break;
	case 0x2C : SRA(H);break;
	case 0x2D : SRA(L);break;
	case 0x2E : tmp8=RMem(HL);
		RF(_N); RF(_H);if(tmp8 & 0x01)SF(_C);else RF(_C);
		tmp8=(u8)(tmp8>>1)|(tmp8 & 0x80);if(tmp8)RF(_Z);else SF(_Z);
		WMem(HL,tmp8);break;
	case 0x2F : SRA(A);break;

#define SWAP(dest)	RF(_N);RF(_H);RF(_C);\
		dest=(dest>>4)|(dest<<4);if(dest)RF(_Z);else SF(_Z)
	case 0x30 : SWAP(B);break;
	case 0x31 : SWAP(C);break;
	case 0x32 : SWAP(D);break;
	case 0x33 : SWAP(E);break;
	case 0x34 : SWAP(H);break;
	case 0x35 : SWAP(L);break;
	case 0x36 : tmp8=RMem(HL);
			RF(_N);RF(_H);RF(_C);
			tmp8=(u8)((tmp8>>4)|(tmp8<<4));if(tmp8)RF(_Z);else SF(_Z);
			WMem(HL,tmp8);break;
	case 0x37 : SWAP(A);break;

#define SRL(dest)	RF(_N); RF(_H);if(dest & 0x01)SF(_C);else RF(_C);\
		dest>>=1; if(dest)RF(_Z);else SF(_Z)
	case 0x38 : SRL(B);break;
	case 0x39 : SRL(C);break;
	case 0x3A : SRL(D);break;
	case 0x3B : SRL(E);break;
	case 0x3C : SRL(H);break;
	case 0x3D : SRL(L);break;
	case 0x3E : tmp8=RMem(HL);
		RF(_H);if(tmp8 & 0x01)SF(_C);else RF(_C);
		tmp8>>=1;if(tmp8)RF(_Z);else SF(_Z); RF(_N);
		WMem(HL,tmp8);break;
	case 0x3F : SRL(A);break;

#define BIT(num,dest)	if(dest & num)RF(_Z);else SF(_Z); RF(_N);SF(_H)
	case 0x40 : BIT(0x01,B);break;
	case 0x41 : BIT(0x01,C);break;
	case 0x42 : BIT(0x01,D);break;
	case 0x43 : BIT(0x01,E);break;
	case 0x44 : BIT(0x01,H);break;
	case 0x45 : BIT(0x01,L);break;
	case 0x46 : BIT(0x01,RMem(HL));break;
	case 0x47 : BIT(0x01,A);break;
	case 0x48 : BIT(0x02,B);break;
	case 0x49 : BIT(0x02,C);break;
	case 0x4A : BIT(0x02,D);break;
	case 0x4B : BIT(0x02,E);break;
	case 0x4C : BIT(0x02,H);break;
	case 0x4D : BIT(0x02,L);break;
	case 0x4E : BIT(0x02,RMem(HL));break;
	case 0x4F : BIT(0x02,A);break;
	case 0x50 : BIT(0x04,B);break;
	case 0x51 : BIT(0x04,C);break;
	case 0x52 : BIT(0x04,D);break;
	case 0x53 : BIT(0x04,E);break;
	case 0x54 : BIT(0x04,H);break;
	case 0x55 : BIT(0x04,L);break;
	case 0x56 : BIT(0x04,RMem(HL));break;
	case 0x57 : BIT(0x04,A);break;
	case 0x58 : BIT(0x08,B);break;
	case 0x59 : BIT(0x08,C);break;
	case 0x5A : BIT(0x08,D);break;
	case 0x5B : BIT(0x08,E);break;
	case 0x5C : BIT(0x08,H);break;
	case 0x5D : BIT(0x08,L);break;
	case 0x5E : BIT(0x08,RMem(HL));break;
	case 0x5F : BIT(0x08,A);break;
	case 0x60 : BIT(0x10,B);break;
	case 0x61 : BIT(0x10,C);break;
	case 0x62 : BIT(0x10,D);break;
	case 0x63 : BIT(0x10,E);break;
	case 0x64 : BIT(0x10,H);break;
	case 0x65 : BIT(0x10,L);break;
	case 0x66 : BIT(0x10,RMem(HL));break;
	case 0x67 : BIT(0x10,A);break;
	case 0x68 : BIT(0x20,B);break;
	case 0x69 : BIT(0x20,C);break;
	case 0x6A : BIT(0x20,D);break;
	case 0x6B : BIT(0x20,E);break;
	case 0x6C : BIT(0x20,H);break;
	case 0x6D : BIT(0x20,L);break;
	case 0x6E : BIT(0x20,RMem(HL));break;
	case 0x6F : BIT(0x20,A);break;
	case 0x70 : BIT(0x40,B);break;
	case 0x71 : BIT(0x40,C);break;
	case 0x72 : BIT(0x40,D);break;
	case 0x73 : BIT(0x40,E);break;
	case 0x74 : BIT(0x40,H);break;
	case 0x75 : BIT(0x40,L);break;
	case 0x76 : BIT(0x40,RMem(HL));break;
	case 0x77 : BIT(0x40,A);break;
	case 0x78 : BIT(0x80,B);break;
	case 0x79 : BIT(0x80,C);break;
	case 0x7A : BIT(0x80,D);break;
	case 0x7B : BIT(0x80,E);break;
	case 0x7C : BIT(0x80,H);break;
	case 0x7D : BIT(0x80,L);break;
	case 0x7E : BIT(0x80,RMem(HL));break;
	case 0x7F : BIT(0x80,A);break;

#define RES(num,dest)	dest&=num
	case 0x80 : RES(0xFE,B);break;
	case 0x81 : RES(0xFE,C);break;
	case 0x82 : RES(0xFE,D);break;
	case 0x83 : RES(0xFE,E);break;
	case 0x84 : RES(0xFE,H);break;
	case 0x85 : RES(0xFE,L);break;
	case 0x86 : WMem(HL,(u8)(RMem(HL) & 0xFE));break;
	case 0x87 : RES(0xFE,A);break;
	case 0x88 : RES(0xFD,B);break;
	case 0x89 : RES(0xFD,C);break;
	case 0x8A : RES(0xFD,D);break;
	case 0x8B : RES(0xFD,E);break;
	case 0x8C : RES(0xFD,H);break;
	case 0x8D : RES(0xFD,L);break;
	case 0x8E : WMem(HL,(u8)(RMem(HL) & 0xFD));break;
	case 0x8F : RES(0xFD,A);break;
	case 0x90 : RES(0xFB,B);break;
	case 0x91 : RES(0xFB,C);break;
	case 0x92 : RES(0xFB,D);break;
	case 0x93 : RES(0xFB,E);break;
	case 0x94 : RES(0xFB,H);break;
	case 0x95 : RES(0xFB,L);break;
	case 0x96 : WMem(HL,(u8)(RMem(HL) & 0xFB));break;
	case 0x97 : RES(0xFB,A);break;
	case 0x98 : RES(0xF7,B);break;
	case 0x99 : RES(0xF7,C);break;
	case 0x9A : RES(0xF7,D);break;
	case 0x9B : RES(0xF7,E);break;
	case 0x9C : RES(0xF7,H);break;
	case 0x9D : RES(0xF7,L);break;
	case 0x9E : WMem(HL,(u8)(RMem(HL) & 0xF7));break;
	case 0x9F : RES(0xF7,A);break;
	case 0xA0 : RES(0xEF,B);break;
	case 0xA1 : RES(0xEF,C);break;
	case 0xA2 : RES(0xEF,D);break;
	case 0xA3 : RES(0xEF,E);break;
	case 0xA4 : RES(0xEF,H);break;
	case 0xA5 : RES(0xEF,L);break;
	case 0xA6 : WMem(HL,(u8)(RMem(HL) & 0xEF));break;
	case 0xA7 : RES(0xEF,A);break;
	case 0xA8 : RES(0xDF,B);break;
	case 0xA9 : RES(0xDF,C);break;
	case 0xAA : RES(0xDF,D);break;
	case 0xAB : RES(0xDF,E);break;
	case 0xAC : RES(0xDF,H);break;
	case 0xAD : RES(0xDF,L);break;
	case 0xAE : WMem(HL,(u8)(RMem(HL) & 0xDF));break;
	case 0xAF : RES(0xDF,A);break;
	case 0xB0 : RES(0xBF,B);break;
	case 0xB1 : RES(0xBF,C);break;
	case 0xB2 : RES(0xBF,D);break;
	case 0xB3 : RES(0xBF,E);break;
	case 0xB4 : RES(0xBF,H);break;
	case 0xB5 : RES(0xBF,L);break;
	case 0xB6 : WMem(HL,(u8)(RMem(HL) & 0xBF));break;
	case 0xB7 : RES(0xBF,A);break;
	case 0xB8 : RES(0x7F,B);break;
	case 0xB9 : RES(0x7F,C);break;
	case 0xBA : RES(0x7F,D);break;
	case 0xBB : RES(0x7F,E);break;
	case 0xBC : RES(0x7F,H);break;
	case 0xBD : RES(0x7F,L);break;
	case 0xBE : WMem(HL,(u8)(RMem(HL) & 0x7F));break;
	case 0xBF : RES(0x7F,A);break;

#define SET(num,dest)	dest|=num
	case 0xC0 : SET(0x01,B);break;
	case 0xC1 : SET(0x01,C);break;
	case 0xC2 : SET(0x01,D);break;
	case 0xC3 : SET(0x01,E);break;
	case 0xC4 : SET(0x01,H);break;
	case 0xC5 : SET(0x01,L);break;
	case 0xC6 : WMem(HL,(u8)(RMem(HL)|0x01));break;
	case 0xC7 : SET(0x01,A);break;
	case 0xC8 : SET(0x02,B);break;
	case 0xC9 : SET(0x02,C);break;
	case 0xCA : SET(0x02,D);break;
	case 0xCB : SET(0x02,E);break;
	case 0xCC : SET(0x02,H);break;
	case 0xCD : SET(0x02,L);break;
	case 0xCE : WMem(HL,(u8)(RMem(HL)|0x02));break;
	case 0xCF : SET(0x02,A);break;
	case 0xD0 : SET(0x04,B);break;
	case 0xD1 : SET(0x04,C);break;
	case 0xD2 : SET(0x04,D);break;
	case 0xD3 : SET(0x04,E);break;
	case 0xD4 : SET(0x04,H);break;
	case 0xD5 : SET(0x04,L);break;
	case 0xD6 : WMem(HL,(u8)(RMem(HL)|0x04));break;
	case 0xD7 : SET(0x04,A);break;
	case 0xD8 : SET(0x08,B);break;
	case 0xD9 : SET(0x08,C);break;
	case 0xDA : SET(0x08,D);break;
	case 0xDB : SET(0x08,E);break;
	case 0xDC : SET(0x08,H);break;
	case 0xDD : SET(0x08,L);break;
	case 0xDE : WMem(HL,(u8)(RMem(HL)|0x08));break;
	case 0xDF : SET(0x08,A);break;
	case 0xE0 : SET(0x10,B);break;
	case 0xE1 : SET(0x10,C);break;
	case 0xE2 : SET(0x10,D);break;
	case 0xE3 : SET(0x10,E);break;
	case 0xE4 : SET(0x10,H);break;
	case 0xE5 : SET(0x10,L);break;
	case 0xE6 : WMem(HL,(u8)(RMem(HL)|0x10));break;
	case 0xE7 : SET(0x10,A);break;
	case 0xE8 : SET(0x20,B);break;
	case 0xE9 : SET(0x20,C);break;
	case 0xEA : SET(0x20,D);break;
	case 0xEB : SET(0x20,E);break;
	case 0xEC : SET(0x20,H);break;
	case 0xED : SET(0x20,L);break;
	case 0xEE : WMem(HL,(u8)(RMem(HL)|0x20));break;
	case 0xEF : SET(0x20,A);break;
	case 0xF0 : SET(0x40,B);break;
	case 0xF1 : SET(0x40,C);break;
	case 0xF2 : SET(0x40,D);break;
	case 0xF3 : SET(0x40,E);break;
	case 0xF4 : SET(0x40,H);break;
	case 0xF5 : SET(0x40,L);break;
	case 0xF6 : WMem(HL,(u8)(RMem(HL)|0x40));break;
	case 0xF7 : SET(0x40,A);break;
	case 0xF8 : SET(0x80,B);break;
	case 0xF9 : SET(0x80,C);break;
	case 0xFA : SET(0x80,D);break;
	case 0xFB : SET(0x80,E);break;
	case 0xFC : SET(0x80,H);break;
	case 0xFD : SET(0x80,L);break;
	case 0xFE : WMem(HL,(u8)(RMem(HL)|0x80));break;
	case 0xFF : SET(0x80,A);break;

#ifdef	_WIN32_GDI
	default   : __assume(0);
#endif	/*_WIN32_GDI*/
	}
}

