
/*	
	GameboyVM - Nintendo Gameboy Emulator
		Copyright 2002 Y_N y_n@users.sourceforge.jp
		Homepage https://sourceforge.jp/projects/gbemu/
*/



static void DrawLine()
{	/*8bitpbg*/
	u8	tdd, tds, tilebit, bgp[4], obp[3];
	u16	tdba, tda, tma, tmpx;
	u8	Start, tpy, mpy, mpx;
	s32	fba, offset, tma_offset;

	static u8 LineBuffer[176];

	if(REG[r_LY]>=144)return;	/*A͕`悵Ȃ*/

	mpy=mpx=tma_offset=0;

	bgp[0]=REG[r_BGP]&0x03;	/*BG,WNDppbg*/
	bgp[1]=(REG[r_BGP]>>2)&0x03;
	bgp[2]=(REG[r_BGP]>>4)&0x03;
	bgp[3]=(REG[r_BGP]>>6)&0x03;

	memset(LineBuffer, 0, 176);

	if(REG[r_LCDC]&0x10){	/*^Cf[^̃x[XAhX̑I*/
		tdba=0x8000;
		offset = 0x00;
	}else{
		tdba=0x8800;
		offset = 0x80;	/*t*/
	}

	Start=REG[r_SCX];
	while(Start>=8){
		Start-=8;	/*^Cf[^̃CΈʒu(0-7)*/
		mpx++;	/*^C}bv̐Έʒu(0-31)*/
	}
	tpy=REG[r_SCY]+REG[r_LY];
	while(tpy>=8){
		tpy-=8;
		mpy++;
	}

	if((REG[r_LCDC]&0x01) && EnableBG){	/*BG̕\*/
		tma=(REG[r_LCDC]&0x08)?0x9C00:0x9800;	/*^C}bṽAhXI*/
		tma+=mpx+(mpy<<5);
		for(tmpx=0; tmpx<168; tmpx+=8){
			if((31-mpx)<(tmpx>>3))tma_offset=32;	/*^C̃I[o[bv*/
			tda=tdba+(0x10*(u8)(RMem((tma++)-tma_offset)+offset))+(tpy<<1);
			tdd=RMem(tda++);
			tds=RMem(tda);
			fba=tmpx+8;
			for(tilebit=0x80; tilebit; tilebit>>=1, fba++){
				if(~tdd&~tds&tilebit)LineBuffer[fba]=bgp[0];
				if(tdd&~tds&tilebit)LineBuffer[fba]=bgp[1];
				if(~tdd&tds&tilebit)LineBuffer[fba]=bgp[2];
				if(tdd&tds&tilebit)LineBuffer[fba]=bgp[3];
			}
		}
	}

	if((REG[r_LCDC]&0x20) && EnableWND){	/*EBhE̕\*/
		if(REG[r_WY]<144 && REG[r_LY]>=REG[r_WY] && REG[r_WX]<167 && REG[r_WX]>=7){
			tpy=REG[r_LY]-REG[r_WY];
			mpy=0;
			while(tpy>=8){
				tpy-=8;
				mpy++;
			}
			tma=(REG[r_LCDC]&0x40)?0x9C00:0x9800;
			tma+=mpy<<5;
			for(tmpx=REG[r_WX]; tmpx<168; tmpx+=8){
				tda=tdba+(0x10*(u8)(RMem(tma++)+offset))+(tpy<<1);
				tdd=RMem(tda++);
				tds=RMem(tda);
				fba=tmpx+Start;
				for(tilebit=0x80; tilebit; tilebit>>=1, fba++){
					if(~tdd&~tds&tilebit)LineBuffer[fba]=bgp[0];
					if(tdd&~tds&tilebit)LineBuffer[fba]=bgp[1];
					if(~tdd&tds&tilebit)LineBuffer[fba]=bgp[2];
					if(tdd&tds&tilebit)LineBuffer[fba]=bgp[3];
				}
			}
		}
	}

	if((REG[r_LCDC]&0x02) && EnableOBJ){	/*XvCg̕\*/
		for(tma=0xFE02; tma<0xFEA2; tma+=4){
			if(!(OBJ_X==0 || OBJ_Y==0)/* && !(OBJ_Y&0x80)*/){	/*XvCg͈͊Oɂ*/
				fba=0;	/*͈͓ɏ*/
				tpy=REG[r_LY]-OBJ_Y+16;
				if(REG[r_LCDC]&0x04){	/*8*16[h*/
					if((tpy<0) || (tpy>=16))fba=255;	/*YW͈͊O*/
					else fba=OBJ_X+Start;	/*XW͈͊O*/
					tmp8=RMem(tma)&0xFE;	/*LSB͖*/
				}else{	/*8*8[h*/
					if((tpy<0) || (tpy>=8))fba=255;	/*YW͈͊O*/
					else fba=OBJ_X+Start;	/*XW͈͊O*/
					tmp8=RMem(tma);
				}
				if(0<=fba && fba<168){	/*XvCgʊȌꍇI[o[t[*/
					/*offset=(OBJ_F&0x40)?0x10-(tpy<<1):(tpy<<1);*/	/*XvCgY]*/
					offset=tpy<<1;	/*XvCgY]*/
					tda=0x8000+(tmp8<<4)+offset;
					tdd=RMem(tda++);
					tds=RMem(tda);
					/*OBJppbg, ʂQrbg͓F*/
					obp[0]=(OBJ_F&0x10)?0x03&(REG[r_OBP1]>>2):0x03&(REG[r_OBP0]>>2);
					obp[1]=(OBJ_F&0x10)?0x03&(REG[r_OBP1]>>4):0x03&(REG[r_OBP0]>>4);
					obp[2]=(OBJ_F&0x10)?0x03&(REG[r_OBP1]>>6):0x03&(REG[r_OBP0]>>6);
					for(tilebit=OBJ_F&0x20?0x01:0x80; tilebit;	/*XvCĝX]*/
						tilebit=OBJ_F&0x20?tilebit*2:tilebit/2, fba++){
						if(tdd&~tds&tilebit)LineBuffer[fba]=obp[0];
						if(~tdd&tds&tilebit)LineBuffer[fba]=obp[1];
						if(tdd&tds&tilebit)LineBuffer[fba]=obp[2];
					}
				}
			}
		}
	}

	fba=REG[r_LY]*160;
	for(tmpx=0; tmpx<160; tmpx++){
		FrameBuffer[fba+tmpx]=LineBuffer[tmpx+Start+8];
	}

}



#ifdef	_WIN32_GDI
static void DrawLine16()
{	/*16bitrbg}bv*/
	u8	tdd, tds, tilebit;
	u16	tdba, tda, tma, tmpx;
	u8	Start, tpy, mpy, mpx, offset, tma_offset;
	u32	fba;
	static u16 LineBuffer[168];
	u16 bgp[4], obp[3];

	if(REG[r_LY]>=144)return;	/*A͕`悵Ȃ*/

	mpy=mpx=tma_offset=0;

	bgp[0]=Colours16[(REG[r_BGP]&0x03)];	/*BG,WNDppbg*/
	bgp[1]=Colours16[(REG[r_BGP]>>2&0x03)];
	bgp[2]=Colours16[(REG[r_BGP]>>4&0x03)];
	bgp[3]=Colours16[(REG[r_BGP]>>6&0x03)];

	memset(LineBuffer, 0, 168);

	if(REG[r_LCDC]&0x10){	/*^Cf[^̃x[XAhX̑I*/
		tdba=0x8000;
		offset = 0x00;
	}else{
		tdba=0x8800;
		offset = 0x80;	/*t*/
	}

	Start=REG[r_SCX];
	while(Start>=8){
		Start-=8;	/*^Cf[^̃CΈʒu(0-7)*/
		mpx++;	/*^C}bv̐Έʒu(0-31)*/
	}
	tpy=REG[r_SCY]+REG[r_LY];
	while(tpy>=8){
		tpy-=8;
		mpy++;
	}

	if(REG[r_LCDC]&0x01 && EnableBG){	/*BG̕\*/
		tma=(REG[r_LCDC]&0x08)?0x9C00:0x9800;	/*^C}bṽAhXI*/
		tma+=mpx+(mpy<<5);
		for(tmpx=0; tmpx<168; tmpx+=8){
			if((31-mpx)<(tmpx>>3))tma_offset=32;	/*^C̃I[o[bv*/
			tda=tdba+(0x10*(u8)(RMem((tma++)-tma_offset)+offset))+(tpy<<1);
			tdd=RMem(tda++);
			tds=RMem(tda);
			fba=tmpx;
			for(tilebit=0x80; tilebit; tilebit>>=1, fba++){
				if(~tdd&~tds&tilebit)LineBuffer[fba]=bgp[0];
				if(tdd&~tds&tilebit)LineBuffer[fba]=bgp[1];
				if(~tdd&tds&tilebit)LineBuffer[fba]=bgp[2];
				if(tdd&tds&tilebit)LineBuffer[fba]=bgp[3];
			}
		}
	}

	if(REG[r_LCDC]&0x20 && EnableWND){	/*EBhE̕\*/
		if(REG[r_WY]<144 && REG[r_LY]>=REG[r_WY] && REG[r_WX]<167 && REG[r_WX]>=7){
			tpy=REG[r_LY]-REG[r_WY];
			mpy=0;
			while(tpy>=8){
				tpy-=8;
				mpy++;
			}
			tma=(REG[r_LCDC]&0x40)?0x9C00:0x9800;
			tma+=mpy<<5;
			for(tmpx=REG[r_WX]; tmpx<168; tmpx+=8){
				tda=tdba+(0x10*(u8)(RMem(tma++)+offset))+(tpy<<1);
				tdd=RMem(tda++);
				tds=RMem(tda);
				fba=tmpx+Start-8;
				for(tilebit=0x80; tilebit; tilebit>>=1, fba++){
					if(~tdd&~tds&tilebit)LineBuffer[fba]=bgp[0];
					if(tdd&~tds&tilebit)LineBuffer[fba]=bgp[1];
					if(~tdd&tds&tilebit)LineBuffer[fba]=bgp[2];
					if(tdd&tds&tilebit)LineBuffer[fba]=bgp[3];
				}
			}
		}
	}

	if(REG[r_LCDC]&0x02 && EnableOBJ){	/*XvCg̕\*/
		for(tma=0xFE02; tma<0xFEA2; tma+=4){
			if(!(OBJ_X==0||OBJ_Y==0)/* && !(OBJ_Y&0x80)*/){	/*XvCg͈͊Oɂ*/
				fba=1;	/*͈͓ɏ*/
				tpy=REG[r_LY]-OBJ_Y+16;
				if(REG[r_LCDC]&0x04){	/*8*16[h*/
					if((tpy<0)||(tpy>=16))fba=255;	/*YW͈͊O*/
					if(fba!=255)fba=OBJ_X+Start-8;	/*XW͈͊O*/
					tmp8=RMem(tma)&0xFE;	/*LSB͖*/
				}else{	/*8*8[h*/
					if((tpy<0)||(tpy>=8))fba=255;	/*YW͈͊O*/
					if(fba!=255)fba=OBJ_X+Start-8;	/*XW͈͊O*/
					tmp8=RMem(tma);
				}
				if(0<=fba&&fba<160){	/*XvCgʊȌꍇI[o[t[*/
					offset=(OBJ_F&0x40)?0x10-(tpy<<1):(tpy<<1);	/*XvCgY]*/
					tda=0x8000+(tmp8<<4)+offset;
					tdd=RMem(tda++);
					tds=RMem(tda);
					/*OBJppbg, ʂQrbg͓F*/
					obp[0]=(OBJ_F&0x10)?0x03&(REG[r_OBP1]>>2):0x03&(REG[r_OBP0]>>2);
					obp[1]=(OBJ_F&0x10)?0x03&(REG[r_OBP1]>>4):0x03&(REG[r_OBP0]>>4);
					obp[2]=(OBJ_F&0x10)?0x03&(REG[r_OBP1]>>6):0x03&(REG[r_OBP0]>>6);
					obp[0]=Colours16[(obp[0])];
					obp[1]=Colours16[(obp[1])];
					obp[2]=Colours16[(obp[2])];
					for(tilebit=OBJ_F&0x20?0x01:0x80; tilebit;	/*XvCĝX]*/
						tilebit=OBJ_F&0x20?tilebit*2:tilebit/2, fba++){
						if(tdd&~tds&tilebit)LineBuffer[fba]=obp[0];
						if(~tdd&tds&tilebit)LineBuffer[fba]=obp[1];
						if(tdd&tds&tilebit)LineBuffer[fba]=obp[2];
					}
				}
			}
		}
	}

	fba=REG[r_LY]*160;
	for(tmpx=0; tmpx<160; tmpx++){
		FrameBuffer16[fba+tmpx]=LineBuffer[tmpx+Start];
	}

}

void Smoothing()
{
	int	x0=10,y0=10,x1=160,y1=144;
	int i,j,k,l;
	int	ra,ga,ba,rb,gb,bb,rc,gc,bc,rd,gd,bd;
	int	rab,rcd,gab,gcd,bab,bcd,rabcd,gabcd,babcd;
	int	size=5;
	u16	color;

	for(j=size/2;j<143-size/2;j+=size){
		for(i=size/2;i<159-size/2;i+=size){
		color=FrameBuffer[x1+i,y0+j];
		ra=(color>>10)&0x1F;
		ga=(color>>5)&0x1F;
		ba=color&0x1F;
		color=FrameBuffer[x1+i+size,y0+j];
		rb=(color>>10)&0x1F;
		gb=(color>>5)&0x1F;
		bb=color&0x1F;
		color=FrameBuffer[x1+i,y0+j+size];
		rc=(color>>10)&0x1F;
		gc=(color>>5)&0x1F;
		bc=color&0x1F;
		color=FrameBuffer[x1+i+size,y0+j+size];
		rd=(color>>10)&0x1F;
		gd=(color>>5)&0x1F;
		bd=color&0x1F;
		for(k=0;k<size;k++)
			for(l=0;l<size;l++){
				rab=(rb-ra)*k/size+ra;
				rcd=(rd-rc)*k/size+rc;
				rabcd=(rcd-rab)*l/size+rab;
				gab=(gb-ga)*k/size+ga;
				gcd=(gd-gc)*k/size+gc;
				gabcd=(gcd-gab)*l/size+gab;
				bab=(bb-ba)*k/size+ba;
				bcd=(bd-bc)*k/size+bc;
				babcd=(bcd-bab)*l/size+bab;
				FrameBuffer16[(x0+i+k)*(y1+j+l)]=(rabcd<<10)+(gabcd<<5)+babcd;
			}
		}
	}
}
#endif	/*_WIN32_GDI*/

